/*** EXTERN.H - A part of MAIN.H ( Included into MAIN.H ) ***/

/*==================+===================+===================+===================+===============*/
/*** Global Variable(s) ***/			// Defined at MAIN.C
/*==================+===================+===================+===================+===============*/
extern char **environ;					/*** Environment Variable ( Declare Only !! ) ***/
extern int mp, mp_base, dp, dp_base, rp, fx, sx;
extern void **mem; extern dtab *ds; extern rtab *rs; extern ftab FileTb[];

extern int flag_exerr  , flag_imode  , flag_vfile, flag_eofin, flag_trace, flag_color, flag_debug;
extern int flag_signing, flag_retning, flag_redo , flag_next , flag_last;
extern ctree *result, *last_fx, *last_ct, *last_ar; extern int epos, epar[64];

extern tdbl gl_uptime; extern char *gl_zone; extern long gl_gmtoff;
extern void *sig_vect[]; extern int sig_iall, sig_tall, sig_icnt[], sig_tcnt[];
extern int gl_argc; extern char **gl_argv; extern int gl_spos, gl_colm, gl_skip, tr_file, tr_line;
extern tint ga_cntr, ga_size, gf_cntr, gf_size;

/*==================+===================+===================+===================+===============*/
/*** Global Function(s) ***/			// Defined at ****.C
/*==================+===================+===================+===================+===============*/
// TopLevel: MAIN.C
extern void proc_option(char*), disp_usage(void), disp_verno(void);

// Admin: INST-SYS{CNST,FUNC}.C REINIT.C
extern void inst_syscnst(int,char*[]), inst_sysfunc(void);
extern void init_icpu(void), reinit_icpu(void), reinit_argcmd(void), reinit_env(void), reinit_ltz(void);
extern void reinit_code(char*,int), reinit_data(char*,int);
extern void main_lc2ds(void), main_ds2lc(void), *set_scriptbyfile(char*), *set_scriptbyargv(char*);

// Data: ARRYHS-{MAIN,SUPP}.C DTSUP.C GTSUP.C RWLKUP.C
extern dtab *ca2p_dtab(ctree*), *di2p_dtab(dtab*,int), *dm2p_dtab(dtab*,int,int), *dn2p_dtab(dtab*,int*,int);
extern dtab *du2p_dtab(dtab*,char*), *ds2p_dtab(dtab*,char*), *ri2p_dtab(dtab*,int), *p_elmt(dtab*,int);
extern int n_elmt(dtab*) ,ckasgn_saidx(ctree*,int[]);
extern char *mk_ukey(char*,dtab*), *rv_ukey(char*,int,dtab*); extern int be_stid(char*), fx_hash(char*);

extern tint idx2cdx(int,int); extern int cdx2scp(tint), cdx2idx(tint);
extern dtab *deref(dtab*); extern char *deref_a(dtab*);
extern dtab *cdx2p_dtab(tint  ), *cdx2p_draw(tint  ), *cdx2p_prev(tint  ), *cdx2p_orig(tint  );
extern dtab *ctr2p_dtab(ctree*), *ctr2p_draw(ctree*), *ctr2p_prev(ctree*), *ctr2p_orig(ctree*);
extern void cpy_dtab(dtab*,dtab*); extern int eql_dtab(dtab*,dtab*);
extern void init_dtab(dtab*), udef_dtab(dtab*), null_dtab(dtab*), void_dtab(dtab*);
extern int isdefd(dtab*), isnull(dtab*), isvoid(dtab*), issptr(dtab*), isiptr(dtab*), isdptr(dtab*), isdigv(dtab*);
extern int isstr(dtab*);
extern int istrue(dtab*), isfals(dtab*), ismatx(dtab*), ismatv(dtab*), ismatx_allelmt(dtab*);

extern void X_FREE(void*), *X_ATOM(int), *X_MALL(int), *X_RALL(void*,int);
extern char *X_SDUP(char*), *X_NDUP(char*,int), *X_SCAT(char*,char*), *X_NCAT(char*,char*,int);
extern char *X_SSUB(char*,char*,char*), *X_GSUB(char*,char*,char*), *X_EXPN(char*,int);
extern char *X_GETS(FILE*); extern int isreg(dtab*); extern void regcc(dtab*);

extern int rd_dtab(int,char*), wr_dtab(int,char*,int,int,...); extern dtab *seek_origfunc(int,void*);
extern char *SYS_SHELL(void); extern tdbl SYS_ANGLE(void); extern tint LTZ_OFFSET(void); extern char *LTZ(void);
extern char *FMT_S2S(void), *FMT_I2S(void), *FMT_D2S(void), *FMT_P2S(void), *FMT_N2S(void);
extern char *FMT_SDATE(void), *FMT_STIME(void); extern dtab *PTR2DOLQ(void), *PTR2ARGR(void);
extern dtab *RAW_SOCKET (void),*UDP_SOCKET (void),*TCP_SOCKET (void),*LaA_SOCKET (void);
extern dtab *RAW_TIMEOUT(void),*UDP_TIMEOUT(void),*TCP_TIMEOUT(void);

// Exec: DUMP-{MAIN,SUPP}.C ESCDOL.C SIGNAL.C TOPLVL.C
extern void dump_cpu(void), dump_mem(void), dump_st(void), dump_rt(void), dump_ft(void), dump_dt(tint), dump_ct(tint,int);
extern void strace(ctree*), jtrace(char*,int,char*,char*);
extern int dk(dtab*), dt(dtab*); extern char *dn(dtab*), *dv(dtab*);
extern int ck(ctree*), ct(ctree*); extern char *cn(ctree*), *cv(ctree*);

extern char *evalesc(char*), *rvalesc(char*), *evaldol(char*); extern int chk_evaldol(char*,char**,char**);
extern void rt_handler(int), cu_handler(void);
extern ctree *exe_tlvlstmt(ctree*), *exe_vdefstmt(int,ctree*), *exe_stmtlist(ctree*);
extern ctree *exe_flowctrl(ctree*), *eva_expr(ctree *,int), *chk_nullfx(void);

/*==================+===================+===================+===================+===============*/
/*** Syntax ***/						// Flex & Bison
/*==================+===================+===================+===================+===============*/
// ( flex.l )
extern int yylex(void), yylineno;		/*** ( Flex: Scanner Func() & Line Number			) ***/
extern FILE *yyin, *yyout;				/*** ( Flex: Input File & Output File				) ***/

// ( fsup.c )
extern char *fn(int); extern char **fv(int); extern int yy_input2(char*,int), chk_rsvdkeywd(char*), conv_esc2int(char);
extern void savchg_f4yy(int,char*), reschg_f4yy(void); extern char *sloc(int,int), *eloc(void);
extern tint param1(char*), param2(char*); extern void disp_colhelp(void);

// ( bison.y )
extern int yyparse(void);				/*** ( Bison: Parser Func()							) ***/

// ( bsup.c )
extern int iscgap(ctree*), lgap(ctree*), lcnt(ctree*), lcnta(ctree*), lcntg(ctree*);
extern ctree *lptr(ctree*,int),*lptra(ctree*,int), *lptrg(ctree*,int);

// ( esup.c )
extern void diag(ctree*), yyerror(char*);

// ( isup.c )
extern ctree *mk_ctree(int,int,int,int,ctree*,ctree*,ctree*), *mk_cleaf(int,int,int,int,tint), *mk_cgap(void);
extern ctree *dg_ctree(ctree*,ctree*), *ext_ctrdtab(ctree*), *ext_ctrdtabmult(ctree*,int);
extern ctree *inst_fparam  (char*,int,int,int,int,int,int,ctree*);
extern ctree *inst_struid  (char*,int,int,int,int,int,int,ctree*);
extern ctree *lkinst_lparam(char*,int,int,int,int,int,int,ctree*);
extern ctree *lkinst_rparam(char*,int,int,int,int,int,int,ctree*);
extern ctree *lkinst_fnam4defx(char*,int,int,int,int,int,int,ctree*);
extern ctree *lkinst_fnam4call(char*,int,int,int,int,int,int,ctree*);

/*==================+===================+===================+===================+===============*/
/**** Icode ***/						// Virtual Code
/*==================+===================+===================+===================+===============*/
// Lang.Oper:
extern ctree *x_arth(ctree*), *x_asgn(ctree*), *x_bit1(ctree*), *x_bit2(ctree*), *x_bkqt(ctree*);
extern ctree *x_call(ctree*,int), *x_cmpr(ctree*), *x_eqne(ctree*), *x_imed(ctree*), *x_lgc1(ctree*);
extern ctree *x_lgc2(ctree*), *x_ppmm(ctree*), *x_qcol(ctree*), *x_rene(ctree*);
extern ctree *x_shqt(ctree*), *x_unop(ctree*);

// Lang.Flow:
extern ctree *x_redo(ctree*), *x_next(ctree*), *x_last(ctree*), *x_retn(ctree*);
extern ctree *x_each(ctree*), *x_loop(ctree*);
extern ctree *x_if  (ctree*), *x_elif(ctree*), *x_else(ctree*), *x_swch(ctree*);
extern ctree *ex_ifif(char*,ctree*); extern int match_exwclist(ctree*,ctree*);
extern ctree *x_fors(ctree*), *x_whil(ctree*), *x_dowh(ctree*), *ex_while(ctree*,int);
extern ctree                  *x_untl(ctree*), *x_doun(ctree*), *ex_until(ctree*,int);

// Data.Call:
extern ctree *i_shift(ctree*), *i_opshift(ctree*), *i_unshift(ctree*);
extern ctree *i_int(ctree*), *i_dbl(ctree*), *i_atov(ctree*);
extern ctree *i_bin(ctree*), *i_oct(ctree*), *i_dec (ctree*), *i_hex (ctree*);
extern ctree *i_str(ctree*), *i_ptr(ctree*), *i_reg (ctree*), *i_dup (ctree*);
extern ctree *i_sort (ctree*), *i_rsort(ctree*), *do_sort(ctree*,int);
extern int nval_compare(const void*,const void*), rval_compare(const void*,const void*);
extern int nstr_compare(const void*,const void*), rstr_compare(const void*,const void*);
extern int func_compare(const void*,const void*);

extern ctree *i_isdef(ctree*), *i_type (ctree*), *i_erase(ctree*), *i_p(ctree*), *i_d(ctree*);
extern ctree *i_isalnum(ctree*), *i_isalpha(ctree*), *i_isascii(ctree*), *i_isblank(ctree*), *i_iscntrl(ctree*);
extern ctree *i_isdigit(ctree*), *i_isgraph(ctree*), *i_islower(ctree*), *i_isprint(ctree*), *i_ispunct(ctree*);
extern ctree *i_isspace(ctree*), *i_isupper(ctree*), *i_isxdigit(ctree*);
extern ctree *i_vals(ctree*), *i_keys(ctree*), *i_tags(ctree*), *mk_arry(ctree*,int), *i_size(ctree*), *i_strlen(ctree*);
extern ctree *i_row(ctree*) , *i_col(ctree*) , *i_ndim(ctree*), *i_shape(ctree*);

// File.Call:
extern FILE *ret_fp(ctree *,char *); extern ctree *i_open(ctree *),*i_close(ctree *),*i_flush (ctree *);
extern ctree *i_getpos(ctree *),*i_setpos(ctree *),*i_movpos(ctree *),*i_rewind(ctree *),*do_ctrpos(ctree*,int);
extern ctree *i_getc  (ctree *),*i_gets  (ctree *),*i_getn  (ctree *),*do_gets(ctree*,int);
extern ctree *i_putc  (ctree *),*i_puts  (ctree *),*i_putn  (ctree *);
extern ctree *i_ungetc(ctree *),*i_ungets(ctree *),*i_ungetn(ctree *);
extern ctree *i_print (ctree *),*i_eprint(ctree *),*i_fprint(ctree *),*i_sprint(ctree *),*i_dying (ctree *);
extern char *make_outstr(char *,ctree *,int,int);
extern ctree *i_read  (ctree *),*i_write(ctree *);
extern int set_prnfmt(char *,char *,int); extern char *expand_tfmt(char *),*ival2binstr(char *,tint);

// Inet.Call:
extern tint str_iphn2tint(char*),str_posn2tint(int,char*),dtab_iphn2tint(dtab*),dtab_posn2tint(int,dtab*);
extern ctree *i_ip2int(ctree*),*i_ip2str(ctree*),*i_port2int(ctree*),*i_port2str(ctree*);
extern int mk_socket(int,int,dtab*,dtab*); extern ctree *i_sockinfo(ctree*);
extern ctree *i_udp_socket(ctree*),                                     *i_tx_udp(ctree*),*i_rx_udp(ctree*);
extern ctree *i_tcp_socket(ctree*),*i_listen(ctree*),*i_connect(ctree*),*i_tx_tcp(ctree*),*i_rx_tcp(ctree*);
extern ctree *i_raw_socket(ctree*),*i_ping(ctree*); extern void net_alarmhandler(int); extern int set_alarm(tdbl);
extern uint16_t net_checksum(uint16_t*,int);

// Math.Call:
extern ctree *i_sin  (ctree *),*i_cos  (ctree *),*i_tan  (ctree *);
extern ctree *i_asin (ctree *),*i_acos (ctree *),*i_atan (ctree *),*i_atan2(ctree *);
extern ctree *i_j0   (ctree *),*i_j1   (ctree *),*i_jn   (ctree *);
extern ctree *i_y0   (ctree *),*i_y1   (ctree *),*i_yn   (ctree *);
extern ctree *i_sinh (ctree *),*i_cosh (ctree *),*i_tanh (ctree *);
extern ctree *i_asinh(ctree *),*i_acosh(ctree *),*i_atanh(ctree *);
extern ctree *i_ceil (ctree *),*i_floor(ctree *),*i_rint (ctree *),*i_round(ctree *),*i_trunc(ctree *);
extern ctree *i_abs  (ctree *),*i_modf (ctree *),*i_frexp(ctree *),*i_ldexp(ctree *);
extern ctree *i_isinf(ctree *),*i_isnan(ctree *);
extern ctree *i_log  (ctree *),*i_log2 (ctree *),*i_log10(ctree *);
extern ctree *i_exp  (ctree *),*i_exp2 (ctree *),*i_exp10(ctree *);
extern ctree *i_pow  (ctree *),*i_mod  (ctree *),*i_sqrt (ctree *),*i_cbrt (ctree *);
extern ctree *i_lin  (ctree *),*i_dbi  (ctree *);
extern ctree *i_rad2deg(ctree *),*i_rad2dms(ctree *);
extern ctree *i_deg2rad(ctree *),*i_deg2dms(ctree *);
extern ctree *i_dms2rad(ctree *),*i_dms2deg(ctree *);
extern ctree *i_xrot  (ctree*),*i_yrot  (ctree*),*i_zrot  (ctree*);
extern ctree *i_max   (ctree*),*i_min   (ctree*),*i_med   (ctree*),*i_argmax(ctree*),*i_argmin(ctree*),*i_argmed(ctree*);
extern ctree *i_sum   (ctree*),*i_ave   (ctree*);
extern ctree *i_svar  (ctree*),*i_uvar  (ctree*),*i_sdev  (ctree*),*i_udev  (ctree*);
extern ctree *i_lgamma(ctree*),*i_tgamma(ctree*),*i_dnorm (ctree*),*i_pnorm (ctree*),*i_erf   (ctree*),*i_erfc  (ctree*);
extern void *do_lqsum (ctree*,char,tdbl*);
extern ctree *i_srand (ctree*),*i_rand  (ctree*),*i_urand(ctree*),*i_nrand(ctree*);

// Proc.Call:
extern ctree *i_eval    (ctree*), *i_gc_collect(ctree*);
extern ctree *i_getpid  (ctree*), *i_getppid (ctree*), *i_pause   (ctree*), *i_sleep   (ctree*);
extern ctree *i_system  (ctree*), *i_exit    (ctree*);
extern ctree *i_txsig   (ctree*), *i_rxsig   (ctree*);

// Strr.Call:
extern ctree *i_strcmp(ctree*), *i_strcmpi(ctree*), *i_strncmp(ctree*), *i_strncmpi(ctree*);
extern ctree *i_strchr(ctree*), *i_strrchr(ctree*), *i_strstr (ctree*), *i_strrstr (ctree*), *i_strreg(ctree*);
extern ctree *i_ssub  (ctree*), *i_gsub   (ctree*), *i_evalesc(ctree*), *i_rvalesc (ctree*);
extern ctree *i_uc    (ctree*), *i_lc     (ctree*), *i_subchr (ctree*), *i_substr  (ctree*);
extern ctree *i_chop  (ctree*), *i_strip  (ctree*), *i_hstrip (ctree*), *i_tstrip  (ctree*);
extern ctree *i_split (ctree*), *i_psplit (ctree*), *i_scan   (ctree*), *i_pscan   (ctree*);

// Time.Call:
extern ctree *i_t2utc  (ctree*), *i_t2ltz  (ctree*), *i_t2elp  (ctree*);
extern ctree *i_utc2t  (ctree*), *i_ltz2t  (ctree*), *i_elp2t  (ctree*);
extern ctree *i_utc2ltz(ctree*), *i_ltz2utc(ctree*), *i_tm_norm(ctree*);
extern ctree *i_t2ymd  (ctree*), *i_t2lymd (ctree*), *i_ymd2t  (ctree*), *i_lymd2t (ctree*);
extern ctree *i_sdate  (ctree*), *i_lsdate (ctree*), *i_stime  (ctree*), *i_lstime (ctree*);
extern ctree *i_sftime (ctree*), *i_lsftime(ctree*), *i_sptime (ctree*), *i_lsptime(ctree*);
extern ctree *i_time   (ctree*), *i_times  (ctree*), *i_isleap (ctree*);
extern void  asgn_tm2dtab(struct tm*,dtab*,int), asgn_dtab2tm(dtab*,struct tm*,int);
